<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
    >
      <el-form-item label="企业名称" prop="enterpriseName">
        <el-input
          v-model="queryParams.enterpriseName"
          placeholder="请输入企业名称"
          clearable
          @input="performEnterpriseNameSearch"
        />
      </el-form-item>
      <div>
        <ul v-if="enterpriseNameSuggestions.length" class="suggestion-list">
          <li
            v-for="suggestion in enterpriseNameSuggestions"
            :key="suggestion"
            @click="selectEnterpriseName(suggestion)"
          >
            {{ suggestion }}
          </li>
        </ul>
      </div>
      <el-form-item label="坐落地" prop="location">
        <el-input
          v-model="queryParams.location"
          placeholder="请输入坐落地"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="行业代码" prop="code">
        <el-input
          v-model="queryParams.code"
          placeholder="请输入行业代码"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="企业分类" prop="typeNum">
        <el-select v-model="queryParams.typeNum" style="width: 100%">
            <el-option
              v-for="item in enterTypeList"
              :key="item.number"
              :value="item.number"
              :label="keyToChinese(item.number)"
            >
            </el-option>
          </el-select>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['enterprise:enterprise:add']"
          >新增</el-button
        >
      </el-col>
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="success"-->
      <!--          plain-->
      <!--          icon="el-icon-edit"-->
      <!--          size="mini"-->
      <!--          :disabled="single"-->
      <!--          @click="handleUpdate"-->
      <!--          v-hasPermi="['enterprise:enterprise:edit']"-->
      <!--        >修改</el-button>-->
      <!--      </el-col>-->
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="danger"-->
      <!--          plain-->
      <!--          icon="el-icon-delete"-->
      <!--          size="mini"-->
      <!--          :disabled="multiple"-->
      <!--          @click="handleDelete"-->
      <!--          v-hasPermi="['enterprise:enterprise:remove']"-->
      <!--        >删除</el-button>-->
      <!--      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['enterprise:enterprise:export']"
          >导出</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="info"
          icon="el-icon-upload2"
          size="mini"
          @click="handleImport"
          v-hasPermi="['enterprise:enterprise:import']"
          >导入</el-button
        >
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="enterpriseList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="序号" align="center" prop="id" />
      <el-table-column label="企业名称" align="center" prop="enterpriseName" />
      <el-table-column label="坐落地" align="center" prop="location" />
      <el-table-column label="行业代码" align="center" prop="code" />
      <el-table-column label="企业分类" align="center" prop="typeName" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['enterprise:enterprise:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['enterprise:enterprise:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改enterprise对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="企业名称" prop="enterpriseName">
          <el-input
            v-model="form.enterpriseName"
            placeholder="请输入企业名称"
          />
        </el-form-item>
        <el-form-item label="坐落地" prop="location">
          <el-input v-model="form.location" placeholder="请输入坐落地" />
        </el-form-item>
        <el-form-item label="行业代码" prop="code">
          <el-input v-model="form.code" placeholder="请输入行业代码" />
        </el-form-item>
        <el-form-item label="企业分类" prop="typeNum">
          <el-select v-model="form.typeNum" style="width: 100%">
            <el-option
              v-for="item in enterTypeList"
              :key="item.number"
              :value="item.number"
              :label="keyToChinese(item.number)"
            >
            </el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px">
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          将文件拖到此处，或
          <em>点击上传</em>
        </div>
        <div class="el-upload__tip" slot="tip">
          <el-link
            type="primary"
            style="font-size: 12px"
            @click="importTemplate"
            >点击此处下载文件上传模板</el-link
          >
        </div>
        <div class="el-upload__tip" style="color: red" slot="tip">
          提示：仅允许导入“xls”或“xlsx”格式文件！
        </div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listEnterprise,
  getEnterprise,
  delEnterprise,
  addEnterprise,
  updateEnterprise,
  listEnterpriseWithType,
} from "@/api/enterprise/enterprise";
import { getToken } from "@/utils/auth";
import { listEtypeAll } from "@/api/etype/etype";
export default {
  name: "Enterprise",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // enterprise表格数据
      enterpriseList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        enterpriseName: null,
        location: null,
        code: null,
        typeNum: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        enterpriseName: [
          { required: true, message: "企业名称不能为空", trigger: "blur" },
        ],
      },
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/enterprise/enterprise/importData",
      },
      // 企业名称提示列表
      enterpriseNameSuggestions: [],
      // 企业分类列表
      enterTypeList: [],
    };
  },
  created() {
    this.init()
    this.getList();
  },
  methods: {
    init() {
      listEtypeAll().then((res) => {
        this.enterTypeList = res;
        console.log(this.enterTypeList)
      });
    },
    /** 查询enterprise列表 */
    getList() {
      this.loading = true;
      listEnterpriseWithType(this.queryParams).then((response) => {
        this.enterpriseList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
      
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        enterpriseName: null,
        location: null,
        code: null,
        typeNum: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "新增企业";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getEnterprise(id).then((response) => {
        this.form = response.data;
        // console.log(this.form)
        this.open = true;
        this.title = "修改企业实体数据";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          this.form.typeName = this.keyToChinese(this.form.typeNum);
          // console.log(this.form);
          if (this.form.id != null) {
            updateEnterprise(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addEnterprise(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm(
          '是否确认删除编号为"' +
            ids +
            '"的企业？这将会删除所有关于这家企业的数据'
        )
        .then(function () {
          return delEnterprise(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "enterprise/enterprise/export",
        {
          ...this.queryParams,
        },
        `enterprise_${new Date().getTime()}.xlsx`
      );
    },
    handleImport() {
      this.upload.title = "企业（分类）数据导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      this.download(
        "enterprise/enterprise/importTemplate",
        {},
        `enterprise_template_${new Date().getTime()}.xlsx`
      );
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    // 企业名称模糊查询
    performEnterpriseNameSearch() {
      const searchTerm = this.queryParams.enterpriseName;
      if (searchTerm.length) {
        console.log(searchTerm);
        const filteredData = this.enterpriseList.filter((item) =>
          item.enterpriseName.includes(searchTerm)
        );
        this.enterpriseNameSuggestions = filteredData.map(
          (item) => item.enterpriseName
        );
      } else {
        this.enterpriseNameSuggestions = [];
      }
      console.log(this.enterpriseNameSuggestions);
    },
    selectEnterpriseName(suggestion) {
      this.queryParams.enterpriseName = suggestion;
      this.enterpriseNameSuggestions = [];
      this.handleQuery();
    },
    keyToChinese(num) {
      const item = this.enterTypeList.find(element => element.number === num);
      return item ? item.name : null;
    },
  },
};
</script>

<style scoped>
.suggestion-list {
  list-style: none;
  padding: 0;
  margin: 0;
  background-color: #f9f9f9;
  border: 1px solid #ebebeb;
  border-radius: 4px;
  position: absolute;
  z-index: 1000; /* 确保提示框位于最高层 */
  width: 200px; /* 设置提示框的宽度为200px */
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.2); /* 添加阴影效果 */
  margin-top: 5px; /* 与输入框之间的间隔 */
  left: 85px; /* 根据输入框的位置调整提示框的位置，使其居中显示 */
}

.suggestion-list li {
  padding: 5px 10px;
  cursor: pointer;
}

.suggestion-list li:hover {
  background-color: #e1e1e1;
}
</style>
